﻿local api = require "eu07.events"

-- tablica znakow ktore bedziemy printowac
board = {}
-- czy tablica jest wlaczona
boardOn = false

-- robimy funkcje odpowiadajace klawiszom Shift + 0-9
api.event_create("keyctrl00", 0, 0, function(event, activator)
	-- shift + 0 = wlaczenie/wylaczenie tablicy
	boardOn = not boardOn
	if boardOn then
		api.event_dispatch_n("updateBoard", nil, 0)
	end
	--putChar({5, 10}, '6')
	--putText({8, 10}, "Test pisania w Luowym debuggerze!!!")
end)

-- funkcja refreshajaca
api.event_create("onstart_lua", 0, 0, function(event, activator)
	api.event_create("updateBoard", 0, 0, function(event, activator)
		if boardOn then
			api.event_dispatch_n("updateBoard", nil, 0)
			
			-- rysujemy
			clearBoard()
			putText({20, 1}, "Debugger Lua - witamy!!!")
			putText({10, 3}, "Izolacje")
			putText({30, 3}, "Zwrotnice")
			putText({50, 3}, "Semafory")
			putText({10, 5}, "Nazwa")
			putText({30, 5}, "Nazwa")
			putText({50, 5}, "Nazwa")
			putText({25, 4}, "Stan")
			putText({45, 4}, "Stan")
			putText({65, 4}, "Stan")
			putText({25, 5}, " S A")
			putText({45, 5}, " S A")
			putText({65, 5}, " S A")
			putRect({9, 6}, {61, 1}, '-')
			putRect({9, 3}, {1, 18}, '|')
			putRect({29, 3}, {1, 18}, '|')
			putRect({49, 3}, {1, 18}, '|')
			putRect({69, 3}, {1, 18}, '|')
			local deviceTypes = {"track", "turn", "sem"}
			for i = 1, #deviceTypes do
				local deviceType = deviceTypes[i]
				local devicesData = devicesList[deviceType]
				local j = 1
				for name, data in pairs(devicesData) do
					putText({(i * 20) - 10, j + 6}, name)
					local x = 5 + (i * 20)
					if deviceType == "track" then
						if data["occupied"] then
							putChar({x, j + 6}, 'Z')
						else
							putChar({x, j + 6}, '-')
						end
						if data["reserved"] then
							putChar({x + 1, j + 6}, 'R')
						else
							putChar({x + 1, j + 6}, '-')
						end
					end
					if deviceType == "turn" then
						if data["state"] == 0 then
							putChar({x, j + 6}, '+')
						end
						if data["state"] == 1 then
							putChar({x, j + 6}, '-')
						end
					end
					if deviceType == "sem" then
						if data["state"] == 0 then
							putText({x, j + 6}, "S1")
						end
						if data["state"] == 1 then
							putText({x, j + 6}, "Vmx")
						end
						if data["state"] == 2 then
							putText({x, j + 6}, "40")
						end
						if data["state"] == 3 then
							putText({x, j + 6}, "60")
						end
						if data["state"] == 4 then
							putText({x, j + 6}, "100")
						end
						if data["state"] == 5 then
							putText({x, j + 6}, "Sz")
						end
						if data["state"] == 6 then
							putText({x, j + 6}, "Ms1")
						end
						if data["state"] == 7 then
							putText({x, j + 6}, "Ms2")
						end
					end
					if data["broken"] then
						putChar({x + 3, j + 6}, 'X')
					else
						putChar({x + 3, j + 6}, '-')
					end
					j = j + 1
				end
			end
			
			boardLog()
		end
	end)
end)

-- funkcja printujaca
function boardLog()
	for i = 1, #board do
		api.writelog(board[i])
	end
end

-- rysowanie pustej tablicy zeby nie zasmiecac
function emptyBoard()
	local newBoard = {}
	local row = string.rep(" ", 80)
	for i = 1, 20 do
		table.insert(newBoard, row)
	end
	return newBoard
end

-- funkcje rysujace:
-- czyszczenie tablicy
function clearBoard()
	board = emptyBoard()
end

-- zmiana znaku
function putChar(position, character)
	board[position[2]] = setChar(board[position[2]], position[1], character)
end

-- napisanie tekstu
function putText(position, text)
	for i = 1, #text do
		putChar({position[1] + (i - 1), position[2]}, getChar(text, i))
	end
end

-- narysowanie prostokata
function putRect(position, size, character, filled)
	if filled == nil then filled = true end
	for i = 1, size[1] do
		for j = 1, size[2] do
			if filled or i == 1 or i == size[1] or j == 1 or j == size[2] then
				putChar({position[1] + (i - 1), position[2] + (j - 1)}, character)
			end
		end
	end
end
