﻿local api = require "eu07.events"

function initLog()
	os.execute("mkdir .\\lua_log")
	local logFile = io.open(".\\lua_log\\log.txt", "w")
	logFile:write("")
	logFile:close()
	addLog("MaSzyna Lua Event System")
	addLog(version)
end

function addLog(text)
	local logFile = io.open(".\\lua_log\\log.txt", "a")
	logFile:write("[" .. toString(ticks) .. "]\t" .. text .. "\n")
	logFile:close()
end

function executeFunc(data)
	-- dane TYLKO JEDNEJ FUNKCJI: {name = "...", params = {parametr1, parametr2, parametr3, ...}}
	return _G[data["name"]](unpack(data["params"]))
end

function round(num, decPlaces)
	local mult = 10 ^ (decPlaces or 0)
	return math.floor(num * mult + 0.5) / mult
end

function randomBool()
	local rnd = api.random(0, 2)
	if rnd < 1 then return false else return true end
end

function toString(data, indent, indentActive)
	indent = indent or 0
	if indentActive == nil then
		indentActive = true
	end
	local text = ""
	if indentActive then
		text = string.rep("\t", indent)
	end
	local dataType = type(data)
	if dataType == "table" then
		text = text .. "{\n"
		for key, value in pairs(data) do
			text = text .. toString("[" .. toString(key) .. "] " .. toString(value, indent + 1, false), indent + 1) .. "\n"
		end
		text = text .. toString("}", indent)
	else
		text = text .. tostring(data)
	end
	return text
end

function getChar(text, position)
	return string.sub(text, position, position)
end

function setChar(text, position, character)
	return string.sub(text, 1, position - 1) .. character .. string.sub(text, position + 1)
end

function checkVariables(conditions)
	-- skladnia: {zmienna1 = wartosc1, zmienna2 = wartosc2, ...}
	-- zmienna moze byc tekstem, ale moze byc tez kolejnym arrayem jesli ma to byc wynik funkcji, wowczas skladnia podana w executeFunc
	for key, value in pairs(conditions) do
		if type(key) == "string" and _G[key] ~= value then return false end
		if type(key) == "table" and executeFunc(key) ~= value then return false end
	end
	return true
end

function tableHas(data, shouldHave)
	for key, value in pairs(data) do
		if value == shouldHave then return true end
	end
	return false
end

function tableKeys(data)
	local keys = {}
	for key, value in pairs(data) do
		table.insert(keys, key)
	end
	return keys
end

function retrieveFromTable(tableName, items)
	local value = _G[tableName]
	for i = 1, #items do
		local item = items[i]
		value = value[item]
	end
	return value
end