﻿--local api = require "eu07.events"
local kernel = require "scenery/lua/kernel"

-- drzewo inicjalizacji:

-- lista stacji (array)
	-- nazwa = stacja 1 (array)
		-- shortName = skrot (string)
		-- type = typ (int) - 0: stacja, 1: szlak
		-- track = izolacje (array)
			-- izolacja 1 (string)
			-- izolacja 2 (string)
			-- izolacja 3 (string)
			-- [...]
		-- turn = zwrotnice (array)
			-- zwrotnica 1 (string)
			-- zwrotnica 2 (string)
			-- zwrotnica 3 (string)
			-- [...]
		-- sem = semafory (array)
			-- nazwa = semafor 1 (array)
				-- type = typ (bool) - true: ksztaltowy, false: swietlny
				-- repeaters = powtarzacze (array)
					-- powtarzacz 1 (string)
					-- powtarzacz 2 (string)
					-- powtarzacz 3 (string)
					-- [...]
				-- routes = przebiegi (array)
					-- nazwa = przebieg 1 (array)
						-- wariant 1 (array)
							-- speed = predkosc (int) - 0: S1, 1: Vmax, 2: 40 km/h, 3: 60 km/h, 4: 100 km/h, 5: Sz, 6: Ms1, 7: Ms2
							-- nextSem = semafor przed nim (string)
							-- prevSem = semafor za nim (string)
							-- turnouts = zwrotnice (array)
								-- ustawienie zwrotnicy 1 (string)
								-- ustawienie zwrotnicy 2 (string)
								-- ustawienie zwrotnicy 3 (string)
								-- [...]
							-- tracks = izolacje (array)
								-- izolacja 1 (string)
								-- izolacja 2 (string)
								-- izolacja 3 (string)
								-- [...]
						-- wariant 2 (array)
						-- wariant 3 (array)
					-- przebieg 2 (array)
					-- przebieg 3 (array)
					-- [...]
			-- semafor 2 (array)
			-- semafor 3 (array)
			-- [...]
	-- stacja 2 (array)
	-- stacja 3 (array)
	-- [...]

init(
{
	["stacja1"]={
		["shortName"]="stacja1",
		["type"]=0,
		["track"]={"t1","t2","zwr1","zwr2"},
		["turn"]={"zwr01","zwr02"},
		["sem"]={
			["a"]={
				["type"]=false,
				["repeaters"]={},
				["routes"]={
					["1"]={
						{
							["speed"]=1,
							["nextSem"]="k",
							["prevSem"]=nil,
							["turnouts"]={"zwr01+"},
							["tracks"]={"zwr1","t1"}
						}
					},
					["2"]={
						{
							["speed"]=2,
							["nextSem"]="j",
							["prevSem"]=nil,
							["turnouts"]={"zwr01-"},
							["tracks"]={"zwr1","t2"}
						}
					}
				}
			},
			["b"]={
				["type"]=false,
				["repeaters"]={"psb1","psb2"},
				["routes"]={
					["a"]={
						{
							["speed"]=2,
							["nextSem"]=nil,
							["prevSem"]="p",
							["turnouts"]={"zwr01-"},
							["tracks"]={"zwr1","szlak1_t1"}
						}
					}
				}
			},
			["c"]={
				["type"]=false,
				["repeaters"]={"psc1","psc2"},
				["routes"]={
					["a"]={
						{
							["speed"]=1,
							["nextSem"]=nil,
							["prevSem"]="p",
							["turnouts"]={"zwr01+"},
							["tracks"]={"zwr1","szlak1_t1"}
						}
					}
				}
			},
			["j"]={
				["type"]=false,
				["repeaters"]={"psj1","psj2"},
				["routes"]={
					["b"]={
						{
							["speed"]=2,
							["nextSem"]=nil,
							["prevSem"]="a",
							["turnouts"]={"zwr02-"},
							["tracks"]={"zwr2","szlak2_t1"}
						}
					}
				}
			},
			["k"]={
				["type"]=false,
				["repeaters"]={"psk1","psk2"},
				["routes"]={
					["b"]={
						{
							["speed"]=1,
							["nextSem"]=nil,
							["prevSem"]="a",
							["turnouts"]={"zwr02+"},
							["tracks"]={"zwr2","szlak2_t1"}
						}
					}
				}
			},
			["p"]={
				["type"]=false,
				["repeaters"]={},
				["routes"]={
					["1"]={
						{
							["speed"]=1,
							["nextSem"]="c",
							["prevSem"]=nil,
							["turnouts"]={"zwr02+"},
							["tracks"]={"zwr2","t1"}
						}
					},
					["2"]={
						{
							["speed"]=2,
							["nextSem"]="b",
							["prevSem"]=nil,
							["turnouts"]={"zwr02-"},
							["tracks"]={"zwr2","t2"}
						}
					}
				}
			}
		}
	},
	["stacja2"]={
		["shortName"]="stacja2",
		["type"]=0,
		["track"]={"t1","t2","zwr1","zwr2"},
		["turn"]={"zwr01","zwr02"},
		["sem"]={
			["a"]={
				["type"]=true,
				["repeaters"]={},
				["routes"]={
					["1"]={
						{
							["speed"]=1,
							["nextSem"]="c",
							["prevSem"]=nil,
							["turnouts"]={"zwr01+"},
							["tracks"]={"zwr1","t1"}
						}
					},
					["2"]={
						{
							["speed"]=2,
							["nextSem"]="d",
							["prevSem"]=nil,
							["turnouts"]={"zwr01-"},
							["tracks"]={"zwr1","t2"}
						}
					}
				}
			},
			["b"]={
				["type"]=false,
				["repeaters"]={},
				["routes"]={
					["1"]={
						{
							["speed"]=4,
							["nextSem"]="f",
							["prevSem"]=nil,
							["turnouts"]={"zwr02+"},
							["tracks"]={"zwr2","t1"}
						}
					},
					["2"]={
						{
							["speed"]=2,
							["nextSem"]="e",
							["prevSem"]=nil,
							["turnouts"]={"zwr02-"},
							["tracks"]={"zwr2","t2"}
						}
					}
				}
			},
			["c"]={
				["type"]=false,
				["repeaters"]={},
				["routes"]={
					["b"]={
						{
							["speed"]=4,
							["nextSem"]=nil,
							["prevSem"]="a",
							["turnouts"]={"zwr02+"},
							["tracks"]={"zwr2","szlak2_t1"}
						}
					}
				}
			},
			["d"]={
				["type"]=false,
				["repeaters"]={},
				["routes"]={
					["b"]={
						{
							["speed"]=2,
							["nextSem"]=nil,
							["prevSem"]="a",
							["turnouts"]={"zwr02-"},
							["tracks"]={"zwr2","szlak2_t1"}
						}
					}
				}
			},
			["e"]={
				["type"]=true,
				["repeaters"]={},
				["routes"]={
					["a"]={
						{
							["speed"]=2,
							["nextSem"]=nil,
							["prevSem"]="b",
							["turnouts"]={"zwr01-"},
							["tracks"]={"zwr1","szlak1_t1"}
						}
					}
				}
			},
			["f"]={
				["type"]=true,
				["repeaters"]={},
				["routes"]={
					["a"]={
						{
							["speed"]=1,
							["nextSem"]=nil,
							["prevSem"]="b",
							["turnouts"]={"zwr01+"},
							["tracks"]={"zwr1","szlak1_t1"}
						}
					}
				}
			}
		}
	},
	["szlak1"]={
		["shortName"]="szlak1",
		["type"]=1,
		["track"]={"t1"},
		["turn"]={},
		["sem"]={}
	},
	["szlak2"]={
		["shortName"]="szlak2",
		["type"]=1,
		["track"]={"t1"},
		["turn"]={},
		["sem"]={}
	}
}
)

linkEvent("wjazd1", {{["name"]="setRoute", ["params"]={"stacja1_a", "1", genOpoznienie("stacja1")}}, {["name"]="setRoute", ["params"]={"stacja1_k", "b", genOpoznienie("stacja1")}}})
linkEvent("wjazd2", {{["name"]="setRoute", ["params"]={"stacja1_p", "2", genOpoznienie("stacja1")}}, {["name"]="setRoute", ["params"]={"stacja1_b", "a", genOpoznienie("stacja1")}}})
linkEvent("wjazd3", {{["name"]="setRoute", ["params"]={"stacja2_b", "1", genOpoznienie("stacja2")}}, {["name"]="setRoute", ["params"]={"stacja2_f", "a", genOpoznienie("stacja2")}}})
linkEvent("wjazd4", {{["name"]="setRoute", ["params"]={"stacja2_a", "2", genOpoznienie("stacja2")}}, {["name"]="setRoute", ["params"]={"stacja2_d", "b", genOpoznienie("stacja2")}}})